import matplotlib
matplotlib.use('WXAgg')

# lab1_1.py -- template for your Task #1 design file
import matplotlib.pyplot as p
import lab1
import numpy as np

# if you're using iPython, the following call enable matplotlib's
# interactive mode so plots will appear immediately -- useful
# when experimenting...
#p.ion()

def plot_data(data):

	xaxis = np.arange(data.shape[0])
	p.plot(xaxis, data, 'r-') # Change to 'g^' to see points on graph
	p.ylabel('Voltage')
	p.xlabel('Sample Number')
	p.grid(True)
	p.title('Receiver Data')
	p.show()

    

# testing code.  Do it this way so we can import this file
# and use its functions without also running the test code.
if __name__ == '__main__':
    # supply some test data to plot_data...
    lab1.task1_test(plot_data)
