# template for Lab #4, Task #1
import lab4
import numpy as np
 
def decode(received): 
    message = []
    # find_sync returns a list of bit-stuffed interleaved
    # blocks, each element of the list is itself a list
    # of 0's and 1's that make up that particular block.
    for block in lab4.find_sync(received,lab4.sync):

		conseq1s = 0
		for n in xrange(len(block)):
			if n >= len(block):
				break
			if block[n] == 1:
				conseq1s+=1
			else:
				conseq1s=0
			if conseq1s == 7:
				block = block[:n]+block[n+1:]
				conseq1s = 0
			
		#print "Block length should be: ",(15*16)," it is: ",len(block)	

        # now block should have exactly 15*16 elements.
        # use lab4.interleave to deinterleave the block.

		deinter_block = lab4.interleave(block, 16)
        

        # for each group of 15 bits in the block, extract
        # the (uncorrected) data bits and use lab4.bin2char
        # to convert them to an ASCII character, which you
        # should append to message

		for i in xrange(len(deinter_block)/15):
			message+= lab4.bin2char(deinter_block[i*15:i*15+8])
        

    lab4.printmsg(message)

if __name__ == '__main__':
    decode(lab4.message)
