# template for Lab #4, Task #2
import lab4
 
def correct_errors(binmsg): 
	
	data = [binmsg[:4], binmsg[4:8]]
	rowparity = binmsg[8:10]
	colparity = binmsg[10:14]
	totparity = binmsg[14]
	
	errorCount = 0
	finalParityError = False
	
	rowErrors = [lab4.even_parity(data[n])!=rowparity[n] for n in range(2)]
	colErrors = [lab4.even_parity([data[0][n]+data[1][n]])!=colparity[n] for n in range(4)]
	totError = lab4.even_parity(binmsg[0:14])!=totparity
	
	for row in range(2):
		for col in range(4):
			if rowErrors[row] and colErrors[col]:
				data[row][col] = 1-data[row][col]
				
	rowErrorCount = rowErrors[0]+rowErrors[1]
	colErrorCount = colErrors[0]+colErrors[1]+colErrors[2]+colErrors[3]
	
	totalErrors = rowErrorCount+colErrorCount
			
	#If there was a single row/col error, and the parity was CORRECT, then there must have been 2 errors
	#Similarly, if there was a row & col error (data error), and the parity was CORRECT, there is a 2nd error		
	if totalErrors == 1 or totalErrors == 2: 
		if totError == False:
			finalParityError = True
			
				
	message = data[0]+data[1]


	if rowErrorCount > 1 or colErrorCount > 1 or finalParityError:
		raise lab4.DecodingError,"uncorrectable error!"
	
	return message
	

if __name__ == '__main__':
	lab4.test_correct_errors(correct_errors)
