# template for Lab #2, Task #1
import matplotlib
matplotlib.use('WXAgg')
import lab2
import numpy as np
import matplotlib.pyplot as p

def transmit(bits,npreamble=0,
			 npostamble=0,
			 samples_per_bit=8,
			 v0 = 0.0,
			 v1 = 1.0,
			 repeat = 1):

	samples = np.array([])

	for ntimes in range(repeat):
		
		for prefix in range(npreamble):
			samples = np.append(samples, [v0])
	
		for bit in bits:
			for s in range(samples_per_bit):
				if bit == 1:
					samples = np.append(samples, [v1])
				else:
					samples = np.append(samples, [v0])
				
		for postfix in range(npostamble):
			samples = np.append(samples, [v0])	
			
	return samples

if __name__ == '__main__':
	# give the transmit function a workout, report errors
	lab2.test_transmit(transmit)
