import matplotlib
matplotlib.use('WXAgg')

# template for Lab #2, Task #3
import numpy as np
import matplotlib.pyplot as p
import lab2

# turn on interactive mode, useful if we're using ipython
#p.ion()

def unit_sample_response(channel):
	
	samples = [1.0]+[0.0]*1000
	response = channel(samples)
	
	maxS = 0.0
	count = 0
	for s in range(1000):
		if response[s] > maxS:
			maxS = response[s]
		if response[s]*100 < maxS:
			count += 1
		else:
			count = 0
		if count >= 10:
			break
	
	return response[:s]
	

if __name__ == '__main__':
	# plot the unit-sample response of our two channels
	lab2.plot_unit_sample_response(unit_sample_response,lab2.channel1)
	lab2.plot_unit_sample_response(unit_sample_response,lab2.channel2)

	# interact with plots before exiting.  p.show() returns
	# after all plot windows have been closed by the user.
	# Not needed if using ipython
	p.show()  
